{ KOL MCK } // Do not remove this line!
{$DEFINE KOL_MCK}
unit Unit1;

interface

{$IFDEF KOL_MCK}
uses Windows, Messages, KOL {$IFNDEF KOL_MCK}, mirror, Classes, Controls,
  mckControls, mckObjs, Graphics, mckCtrls {$ENDIF (place your units here->)};
{$ELSE}
{$I uses.inc}
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs;
{$ENDIF}

type
  {$IFDEF KOL_MCK}
  {$I MCKfakeClasses.inc}
  {$IFDEF KOLCLASSES} {$I FMainclass.inc} {$ELSE OBJECTS} PFMain = ^TFMain; {$ENDIF CLASSES/OBJECTS}
  {$IFDEF KOLCLASSES}{$I TFMain.inc}{$ELSE} TFMain = object(TObj) {$ENDIF}
    Form: PControl;
  {$ELSE not_KOL_MCK}
  TFMain = class(TForm)
  {$ENDIF KOL_MCK}
    KOLProject1: TKOLProject;
    KOLForm1: TKOLForm;
    LV: TKOLListView;
    bbGo: TKOLBitBtn;
    bbBrowse: TKOLBitBtn;
    cbExt: TKOLComboBox;
    Label2: TKOLLabel;
    Label3: TKOLLabel;
    ODir: TKOLOpenDirDialog;
    ePath: TKOLEditBox;
    bbRestore: TKOLBitBtn;
    bbStop: TKOLBitBtn;
    GPTop: TKOLGradientPanel;
    RBDelete: TKOLRadioBox;
    RBRename: TKOLRadioBox;
    LblInfo: TKOLLabel;
    Panel1: TKOLPanel;
    bbAbout: TKOLBitBtn;
    bbStopRestore: TKOLBitBtn;
    bbRenAll: TKOLBitBtn;
    ebRenExt: TKOLEditBox;
    GB1: TKOLGroupBox;
    ebRenOrg: TKOLEditBox;
    bbDelete: TKOLBitBtn;
    bbSelectAll: TKOLBitBtn;
    bbClearAll: TKOLBitBtn;
    bbClearResult: TKOLBitBtn;
    bbDelList: TKOLBitBtn;
    procedure bbGoClick(Sender: PObj);
    procedure LVColumnClick(Sender: PControl; Idx: Integer);
    procedure bbBrowseClick(Sender: PObj);
    procedure bbRestoreClick(Sender: PObj);
    procedure bbStopClick(Sender: PObj);
    procedure LVKeyDown(Sender: PControl; var Key: Integer;
      Shift: Cardinal);
    procedure KOLForm1Close(Sender: PObj; var Accept: Boolean);
    procedure KOLForm1FormCreate(Sender: PObj);
    procedure KOLForm1Resize(Sender: PObj);
    procedure RBDeleteClick(Sender: PObj);
    procedure bbGoMouseMove(Sender: PControl; var Mouse: TMouseEventData);
    procedure bbGoMouseLeave(Sender: PObj);
    procedure bbGoMouseDown(Sender: PControl; var Mouse: TMouseEventData);
    procedure bbAboutClick(Sender: PObj);
    procedure bbStopRestoreClick(Sender: PObj);
    procedure bbDeleteClick(Sender: PObj);
    procedure bbRenAllClick(Sender: PObj);
    procedure bbSelectAllClick(Sender: PObj);
    procedure bbClearAllClick(Sender: PObj);
    procedure bbClearResultClick(Sender: PObj);
    procedure bbDelListClick(Sender: PObj);
  private
    { Private declarations }
    StopSearch,Busy,StopRestore : Boolean;
 {   Checkdate,CheckSize: Boolean;
    Date1,date2 : TFileTime;
    Size1,Size2 : I64;     }
    iTotal : Integer;
    VirusSize : Integer;
    ListVirusSize : PStrList;
    procedure AddFromPath(const Path,ext: String; Recursion: Boolean);
    function DetectVirusSz(idx: integer; FileName: string): Integer;
    function StringFound(text:string; stream:PStream): Boolean;
    function VirusListed(size: integer): boolean;
    Procedure DeleteRename(Delete : Boolean);
  public
    { Public declarations }
  end;

var
  FMain {$IFDEF KOL_MCK} : PFMain {$ELSE} : TFMain {$ENDIF} ;
  { Header DOC, XLS dan PPT }
  { OFFICE_HEADER : array[0..7] of Byte =
     ($D0, $CF, $11, $E0, $A1, $B1, $1A, $E1); }
  OFFICE_HEADER : array[0..4] of Byte = ($D0, $CF, $11, $E0, $A1);
  RTF_HEADER : array[0..4] of byte = ( $7B, $5C, $72, $74, $66);
  
const
  VERSION = '1.0 RC 2';
  CRLF = #13#10;

{$IFDEF KOL_MCK}
procedure NewFMain( var Result: PFMain; AParent: PControl );
{$ENDIF}

implementation

{$IFNDEF KOL_MCK} {$R *.DFM} {$ENDIF}

{$IFDEF KOL_MCK}
{$I Unit1_1.inc}
{$ENDIF}

// ========================== Grab from sysUtils ============================

function StrAlloc(Size: Cardinal): PChar;
begin
  Inc(Size, SizeOf(Cardinal));
  GetMem(Result, Size);
  Cardinal(Pointer(Result)^) := Size;
  Inc(Result, SizeOf(Cardinal));
end;

function StrPos(const Str1, Str2: PChar): PChar; assembler;
asm
        PUSH    EDI
        PUSH    ESI
        PUSH    EBX
        OR      EAX,EAX
        JE      @@2
        OR      EDX,EDX
        JE      @@2
        MOV     EBX,EAX
        MOV     EDI,EDX
        XOR     AL,AL
        MOV     ECX,0FFFFFFFFH
        REPNE   SCASB
        NOT     ECX
        DEC     ECX
        JE      @@2
        MOV     ESI,ECX
        MOV     EDI,EBX
        MOV     ECX,0FFFFFFFFH
        REPNE   SCASB
        NOT     ECX
        SUB     ECX,ESI
        JBE     @@2
        MOV     EDI,EBX
        LEA     EBX,[ESI-1]
@@1:    MOV     ESI,EDX
        LODSB
        REPNE   SCASB
        JNE     @@2
        MOV     EAX,ECX
        PUSH    EDI
        MOV     ECX,EBX
        REPE    CMPSB
        POP     EDI
        MOV     ECX,EAX
        JNE     @@1
        LEA     EAX,[EDI-1]
        JMP     @@3
@@2:    XOR     EAX,EAX
@@3:    POP     EBX
        POP     ESI
        POP     EDI
end;

function StrEnd(const Str: PChar): PChar; assembler;
asm
        MOV     EDX,EDI
        MOV     EDI,EAX
        MOV     ECX,0FFFFFFFFH
        XOR     AL,AL
        REPNE   SCASB
        LEA     EAX,[EDI-1]
        MOV     EDI,EDX
end;

procedure StrDispose(Str: PChar);
begin
  if Str <> nil then
  begin
    Dec(Str, SizeOf(Cardinal));
    FreeMem(Str, Cardinal(Pointer(Str)^));
  end;
end;
// ----------------------------- EOF SysUtils ------------------------------


// ======================== Tips by Peter Below ============================
function ScanFile( const filename: String; const forString: String; caseSensitive: Boolean ): LongInt;
{ returns position of string in file or -1, if not found }
const
  BufferSize= $8001;  { 32K + 1 bytes }
var
  pBuf, pEnd, pScan, pPos: Pchar;
  filesize: LongInt;
  bytesRemaining: LongInt;
  bytesToRead: Integer;
  F: File;
  SearchFor: Pchar;
  oldMode: Word;
begin
  Result := - 1;  { assume failure }
  if (Length( forString ) = 0) or (Length( filename ) = 0) then
    Exit;
  SearchFor := Nil;
  pBuf := Nil;
  { open file as binary, 1 byte recordsize }
  AssignFile( F, filename );
  oldMode := FileMode;
  FileMode := 0;  { read-only access }
  Reset( F, 1 );
  FileMode := oldMode;
  try  { allocate memory for buffer and pchar search string }
    SearchFor := StrAlloc( Length( forString ) +1 );
    StrPCopy( SearchFor, forString );
    if not caseSensitive then  { convert to upper case }
      AnsiUpper( SearchFor );
    GetMem( pBuf, BufferSize );
    filesize := System.Filesize( F );
    bytesRemaining := filesize;
    pPos := Nil;
    while bytesRemaining > 0 do
    begin
      { calc how many bytes to read this round }
      if bytesRemaining >= BufferSize then
        bytesToRead := Pred( BufferSize )
      else
        bytesToRead := bytesRemaining;
        { read a buffer full and zero-terminate the buffer }
      BlockRead( F, pBuf^, bytesToRead, bytesToRead );
      pEnd := @pBuf[ bytesToRead ];
      pEnd^ := #0;
      { scan the buffer. Problem: buffer may contain #0 chars! So we
      treat it as a concatenation of zero-terminated strings. }
      pScan := pBuf;
      while pScan < pEnd do
      begin
        if not caseSensitive then  { convert to upper case }
          AnsiUpper( pScan );
        pPos := StrPos( pScan, SearchFor );  { search for substring }
        if pPos <> Nil then
        begin  { Found it! }
          Result := FileSize - bytesRemaining + LongInt( pPos ) - LongInt( pBuf );
          Break;
        end;
        pScan := StrEnd( pScan );
        Inc( pScan );
      end;
      if pPos <> Nil then
        Break;
      bytesRemaining := bytesRemaining - bytesToRead;
      if bytesRemaining > 0 then
      begin
        { no luck in this buffers load. We need to handle the case of the search string spanning two
        chunks of file now. We simply go back a bit in the file and read from there, thus inspecting some
        characters twice }
        Seek( F, FilePos(F) - Length( forString ));
        bytesRemaining := bytesRemaining + Length( forString );
      end;
    end;
  finally
    CloseFile( F );
    if SearchFor <> Nil then
      StrDispose( SearchFor );
    if pBuf <> Nil then
      FreeMem( pBuf, BufferSize );
  end;
end;
// ---------------------------- EOF Tips ------------------------------------

procedure TFMain.AddFromPath( const Path,ext : String; Recursion: Boolean );
var
  DL : PDirList;
  I,idx  : Integer;
  sz : I64;
  s  : String;
begin
  DL := NewDirListEx( Path,ext, 0 );
  TRY
    if StopSearch then Exit;
    Applet.ProcessMessage;
    DL.Sort( [ ] );
    for I := 0 to DL.Count-1 do
      begin
        if not DL.IsDirectory[ I ] then
        begin
    {      if CheckDate then
          begin
            if FileTimeCompare( DL.Items[ I ].ftLastWriteTime, Date1 ) < 0 then continue;
            if FileTimeCompare( DL.Items[ I ].ftLastWriteTime, Date2 ) >= 0 then continue;
          end;
          if CheckSize then
          begin
            if Cmp64( MakeInt64( DL.Items[ I ].nFileSizeLow, DL.Items[ I ].nFileSizeHigh ), I64( Size1 ) ) < 0 then continue;
            if Cmp64( MakeInt64( DL.Items[ I ].nFileSizeLow, DL.Items[ I ].nFileSizeHigh ), I64( Size2 ) ) > 0 then continue;
          end;   }
          Inc(iTotal);
          idx := LV.LVItemAdd(DL.Names[ I ]);
          LV.LVSetItem(idx,1,DL.Path,I_SKIP,[],I_SKIP,I_SKIP,0);
          sz := MakeInt64( DL.Items[ I ].nFileSizeLow, DL.Items[ I ].nFileSizeHigh);
          if Cmp64(sz,Int2Int64(MaxInt)) = -1 then
            s := Int2Ths(DL.Items[ I ].nFileSizeLow)
          else
            s := Int64_2Str(sz);
            
          LV.LVSetItem(idx,2,s,I_SKIP,[],I_SKIP,I_SKIP,0);
        end;
        if StopSearch then break;
      end;
      if Recursion then
      begin
        DL.ScanDirectoryEx( Path, '*;*.*', FILE_ATTRIBUTE_DIRECTORY );
        DL.Sort( [ ] );
        for I := 0 to DL.Count-1 do
        begin
          if DL.IsDirectory[ I ] then
            AddFromPath( DL.Path + DL.Names[ I ],ext, TRUE );
          if StopSearch then break;
        end;
      end;
    FINALLY
      DL.Free;
    END;
end;

procedure TFMain.bbGoClick(Sender: PObj);
begin
  LblInfo.Caption := 'Searching...';
  LV.Clear;
  iTotal := 0;
  Busy := True;
  bbGo.Enabled := False;
  StopSearch := False;
  AddFromPath(ePath.Text,cbExt.Text,True);
  Busy := false;
  bbGo.Enabled := True;
  if StopSearch then
    LblInfo.Caption := 'Searching stopped, found '+ Int2Ths(iTotal)+' Files'
  else LblInfo.Caption := 'Finish, found '+ Int2Ths(iTotal)+' Files';

  StopSearch := True;
end;

procedure TFMain.LVColumnClick(Sender: PControl; Idx: Integer);
begin
  if not Busy then
    LV.LVSortColumn(Idx);
end;

procedure TFMain.bbBrowseClick(Sender: PObj);
begin
  ODir.Title := 'Select the path to search';
  if ODir.Execute then
    ePath.Text := ODir.Path;
end;

procedure TFMain.bbRestoreClick(Sender: PObj);
var
  i,n,k : Integer;
  info,sFile,sExt : string;
  strm1, strm2 : PStream;
  Header : array[0..4] of Byte;
begin
  if LV.Count = 0 then Exit;
  bbRestore.Enabled := False;
  n :=0;
  VirusSize :=0;
  ListVirusSize.Clear;
  StopRestore := False;
  LblInfo.Caption := 'Restoring files..';
  for i:=0 to LV.Count-1 do
  begin
    if StopRestore then
    begin
      LblInfo.Caption := 'Restore files were stopped';
      Break;
    end;
    sFile := LV.LVItems[i,1]+ LV.LVItems[i,0];
    if trim(sFile) = '' then continue;
    
    LV.LVCurItem := i;
    LV.LVSetItem(i,3,'Analyzing...',I_SKIP,[],I_SKIP,I_SKIP,0);
    Applet.ProcessMessage;

    strm1 := NewReadFileStream(sFile);
    if strm1.Size = 0 then Continue;
    sExt := '';
    
    if ListVirusSize.Count = 0 then DetectVirusSz(i,sFile);
    for k:=0 to ListVirusSize.Count-1 do
    begin
      VirusSize := Str2int(ListVirusSize.Items[k]);
      strm1.Seek(VirusSize,spBegin);
      ZeroMemory(@Header,5);
      strm1.Read(Header,5);
      if CompareMem(@Header,@OFFICE_HEADER,5) then
        break
      else if CompareMem(@Header,@RTF_HEADER,5) then
      begin
        sExt := '.doc';
        break;
      end;
      
      VirusSize := 0;
    end;
    if (ListVirusSize.Count > 0) and (VirusSize = 0) then
       VirusSize := DetectVirusSz(i,sFile);


    if VirusSize < 1 then
    begin
      LV.LVSetItem(i,3,'Not Detected',I_SKIP,[],I_SKIP,I_SKIP,0);
      if VirusSize = 0 then LV.LVSetItem(i,4,'Microsoft Office Document',I_SKIP,[],I_SKIP,I_SKIP,0);
      Continue;
    end;

    Applet.ProcessMessage;
    strm2 := NewMemoryStream;
    strm1.Seek(VirusSize,spBegin);
    LV.LVSetItem(i,3,'Infected...',I_SKIP,[],I_SKIP,I_SKIP,0);
    Applet.ProcessMessage;
    Stream2Stream(strm2,strm1,strm1.Size-VirusSize);

    if sExt = '' then
    begin
      if StringFound('Word',strm2) then
        sExt := '.doc'
      else
      if StringFound('Exce',strm2) or
         StringFound('W'+#00+'o'+#00,strm2) then
        sExt := '.xls'
      else
        sExt := '.dat';
    end;

    strm2.SaveToFile(ChangeFileExt(sFile,sExt),0,Strm2.Size);
    strm1.free;
    strm2.Free;
    Inc(n);
    if RBDelete.Checked then
      begin
        if DeleteFile(PChar(sFile)) then info := 'Virus was deleted'
        else info := 'Delete failed, '+ SysErrorMessage(GetLastError);
      end
    else
    if RBRename.Checked then
    begin
      sExt := trim(ebRenOrg.Text);
      if sExt = '' then sExt := '._vrs'
      else sExt := '.' + sExt;

      if MoveFile(PChar(sFile),PChar(ChangeFileExt(sFile,sExt))) then
        info := 'Org file renamed to : '+ ChangeFileExt(LV.LVItems[i,0],sExt)
      else info := 'Rename failed, '+ SysErrorMessage(GetLastError);
    end; //}
    
    LV.LVSetItem(i,3,'OK... Fixed' ,I_SKIP,[],I_SKIP,I_SKIP,0);
    LV.LVSetItem(i,4,info,I_SKIP,[],I_SKIP,I_SKIP,0);
    Applet.ProcessMessage;
  end;
  bbRestore.Enabled := True;
  if not StopRestore then
    MsgBox('OK... Finish'+ CRLF+
         'Total files infected and restored : '+ Int2Str(n),MB_ICONINFORMATION)
  else
    MsgOK('Restoring files were stopped');
    
  StopRestore := False;
end;

procedure TFMain.bbStopClick(Sender: PObj);
begin
  StopSearch := True;
  LblInfo.Caption := 'Searching Stopped..';
end;

procedure TFMain.LVKeyDown(Sender: PControl; var Key: Integer;
  Shift: Cardinal);
begin
  if Key = VK_DELETE then
    LV.LVDelete(LV.LVFocusItem); 
end;

procedure TFMain.KOLForm1Close(Sender: PObj; var Accept: Boolean);
begin
  if not StopSearch then
  begin
    Accept := False;
    MsgBox('Before Close this window, Stop the searching First',MB_ICONERROR)
  end;

  ListVirusSize.free;
end;

procedure TFMain.KOLForm1FormCreate(Sender: PObj);
begin
  StopSearch := True;
  Form.Caption := 'Restore my files ' + VERSION;
  ListVirusSize := NewStrList;
  bbAbout.Caption := 'About';

  bbGo.Color := GPTop.Color1;
  bbStop.Color := GPTop.Color1;
  bbBrowse.Color := GPTop.Color1;
  bbRestore.Color := GPTop.Color1;
  bbAbout.Color := GPTop.Color1;
  bbStopRestore.Color := GPTop.Color1;
end;

function TFMain.VirusListed(size : integer) : boolean;
var
  i : integer;
begin
  Result := false;
  if ListVirusSize.Count = 0 then exit;

  for i:=0 to ListVirusSize.Count-1 do
  begin
    if ListVirusSize.Items[i] = int2str(size) then
    begin
      Result := True;
      exit;
    end;
  end;
end;

{ Deteksi apakah itu file DOC, XLS, PPT
  jika result = -1 maka file Dokuments / xls
  jika lebih kemungkinan terinfeksi virus / corupt

function TFMain.DetectVirusSz(idx: integer;FileName : string) : Integer;
var
  Ps  : PStream;
  Buf : Array[0..4] of Byte;
  sz,d : cardinal;
begin
  Result := 0;
  if not FileExists(FileName) then exit;
  Ps := NewReadFileStream(FileName);
  Ps.Position :=0;
  sz := ps.Size;
  d := sz div 100;
  if d=0 then d :=1;

  ZeroMemory(@buf,5);
  while Ps.Position <> sz do
  begin
    buf[0] := buf[1];
    buf[1] := buf[2];
    buf[2] := buf[3];
    buf[3] := buf[4];
    ps.Read(buf[4],1);
    if CompareMem(@buf,@OFFICE_HEADER,5) then
    begin
      // We Found it was VIRUS....
      Result := ps.Position - 5;
      if not VirusListed(Result) then
        ListVirusSize.Add(int2str(Result)); 
      Break;
    end;

    if ps.Position mod d = 0 then
    begin
      LV.LVSetItem(idx,3,Int2Str(ps.Position div d )+ '%' ,I_SKIP,[],I_SKIP,I_SKIP,0);
      Applet.ProcessMessage;
    end;
  end;
  Ps.Free;
  Applet.ProcessMessage;
end;        }

function TFMain.DetectVirusSz(idx: integer;FileName : string) : Integer;
var
  s : string;
  i : Integer;
begin
  s :='';
  for i:= Low(OFFICE_HEADER) to High(OFFICE_HEADER) do
   s := s+Chr(OFFICE_HEADER[i]);
  LV.LVSetItem(idx,1,Int2Ths(Result),I_SKIP,[],I_SKIP,I_SKIP,0);
  Applet.ProcessMessage;
  Result := ScanFile(FileName,s,True);
  if not VirusListed(Result) then
    ListVirusSize.Add(int2str(Result));
end;  

procedure TFMain.KOLForm1Resize(Sender: PObj);
begin
  if LV.Width > 560 then
  LV.LVColWidth[4] := LV.Width - 555; 
end;

function TFMain.StringFound(text:string; stream:PStream): Boolean;
var
  buf,tmp : array[0..3] of Char;
  s : string;
begin
  Result := False;
  s := Copy(text,1,4);
  buf[0] := s[1];
  buf[1] := s[2];
  buf[2] := s[3];
  buf[3] := s[4];
  
  ZeroMemory(@tmp,4);
  if stream.Size > 1024*64 then
    stream.Seek(-1024*64,spEnd)
  else
    stream.Seek(0,spBegin);

  while stream.Position <> stream.Size do
  begin
    tmp[0] := tmp[1];
    tmp[1] := tmp[2];
    tmp[2] := tmp[3];
    stream.Read(tmp[3],1);
    if CompareMem(@buf,@tmp,4) then
    begin
      Result := True;
      Break;
    end;
  end;
end;

procedure TFMain.RBDeleteClick(Sender: PObj);
begin
  if RBDelete.Checked then
  begin
    MsgBox('Peringatan...'+CRLF+
           'Dengan mengaktifkan pilihan ini,'+CRLF+
           'file yang terinfeksi virus akan langsung dihapus',
           MB_ICONWARNING);
  end;
end;

procedure TFMain.bbGoMouseMove(Sender: PControl;
  var Mouse: TMouseEventData);
begin
  TKOLBitBtn(Sender).Color := clWhite;

  if pos('files',TKOLBitBtn(Sender).Caption) > 0 then
    TKOLBitBtn(Sender).Font.Color := clMaroon
  else
    TKOLBitBtn(Sender).Font.Color := clBlue;
end;

procedure TFMain.bbGoMouseLeave(Sender: PObj);
begin
  if pos('files',TKOLBitBtn(Sender).Caption) > 0 then
    TKOLBitBtn(Sender).Color := clMaroon
  else
    TKOLBitBtn(Sender).Color := $00C08080;

  TKOLBitBtn(Sender).Font.Color := clWhite;
end;

procedure TFMain.bbGoMouseDown(Sender: PControl;
  var Mouse: TMouseEventData);
begin
  TKOLBitBtn(Sender).Color := $009D4F4F;
  TKOLBitBtn(Sender).Font.Color := clSilver;
end;

procedure TFMain.bbAboutClick(Sender: PObj);
begin
  MsgBox('Restore my files '+ VERSION+CRLF+
         'Freeware 2007 by ebsoft ;)'+CRLF+CRLF+
         'Tools untuk me-restore file Word dan Excel yang terkena virus'+CRLF+
         'Caranya :'+CRLF+
         '1. Cari folder yang terdapat dokumennya'+CRLF+
         '2. Klik Find ( Stop untuk menghentikan pencarian )'+CRLF+
         '3. Klik Restore File untuk mengembalikan dokumen'+CRLF+
         '4. Yang tidak terdeteksi doc atau xls akan berekstensi *.dat'+CRLF+CRLF+
         'Untuk menghapus file di daftar, pilih dan tekan tombol Delete'+CRLF+
         'Pembuat tidak bertanggung jawab jika ada kehilangan / kerusakan data'+CRLF+
         'Pastikan dicoba dulu dengan memilih "Rename Viruses"'+CRLF+CRLF+
         'web : http://ebsoft.web.id  e-mail: ebta_s@yahoo.com',
         MB_ICONINFORMATION);
end;

procedure TFMain.bbStopRestoreClick(Sender: PObj);
begin
  StopRestore := True;
  bbRestore.Enabled := True;
end;

Procedure TFMain.DeleteRename(Delete : Boolean);
var
  i : integer;
  isSelected : Boolean;
  sFile,ext : string;
begin
  if LV.count < 1 then exit;
  isSelected := false;
  for i:=0 to LV.count-1 do
  begin
   if lvisSelect in LV.LVItemState[i] then
     isSelected := True;
   if isSelected then break;
  end;

  if not isSelected then
  begin
    msgBox('Select the file from the list first',
      MB_ICONINFORMATION);
    exit;
  end;


  ext := trim(ebRenExt.Text);
  if not Delete and (ext = '') then
  begin
    msgBox('File extention is empty'+#13#10+
           'Please fill the file extention',MB_ICONERROR);
    exit;
  end;

  ext := '.' + ext;

  if Delete then
    if MsgBox('Are you sure you want to delete the selected files ?'+#13#10+
      'This will delete the files',
      MB_ICONWARNING or MB_YESNO) = ID_NO then exit
    else
  else
  if MsgBox('Are you sure you rename the selected files ?',
      MB_ICONQUESTION or MB_YESNO) = ID_NO then exit;

  for i:=0 to LV.Count-1 do
  begin
    sFile := LV.LVItems[i,1]+ LV.LVItems[i,0];
    if lvisSelect in LV.LVItemState[i] then
      if Delete then
        begin
          if DeleteFile(PChar(sFile)) then
          begin
            LV.LVSetItem(i,0,'',I_SKIP,[],I_SKIP,I_SKIP,0);
            LV.LVSetItem(i,1,'',I_SKIP,[],I_SKIP,I_SKIP,0);
            LV.LVSetItem(i,2,'',I_SKIP,[],I_SKIP,I_SKIP,0);
            LV.LVSetItem(i,4,'',I_SKIP,[],I_SKIP,I_SKIP,0);
          end
        end
      else
        begin
          if  MoveFile(PChar(sFile),PChar(ChangeFileExt(sFile,ext))) then
            LV.LVSetItem(i,0,ExtractFileName(ChangeFileExt(sFile,ext)),I_SKIP,[],I_SKIP,I_SKIP,0);
        end
  end; 
end;

procedure TFMain.bbDeleteClick(Sender: PObj);
begin
  DeleteRename(True);
end;

procedure TFMain.bbRenAllClick(Sender: PObj);
begin
  DeleteRename(False);
end;

procedure TFMain.bbSelectAllClick(Sender: PObj);
begin
  LV.LVSelectAll;
end;

procedure TFMain.bbClearAllClick(Sender: PObj);
begin
  LV.LVItemState[-1] := [lvisBlend];
end;

procedure TFMain.bbClearResultClick(Sender: PObj);
begin
  LV.clear;
end;

procedure TFMain.bbDelListClick(Sender: PObj);
var
  i : integer;
begin
  if LV.count < 1 then exit;
  while true do
  begin
    i := -1;
    i := LV.LVNextSelected(i);
    if i = -1 then break;
    LV.LVDelete(i);
  end;
end;

end.



